<!DOCTYPE html>
<html lang="en">
<head>
     <meta charset="UTF-8">
     <meta http-equiv="X-UA-Compatible" content="IE=edge">
     <meta name="viewport" content="width=device-width, initial-scale=1.0">
     <title>Danh sách các bình luận (comment) của 01 bài viết (post)</title>

     <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
     <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
     <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>
<body>
     <div class="container">
          <div class="text-center my-4">
            <h3 class="text-info">Danh sách các bình luận (comment) của 01 bài viết (post)</h3>
          </div>
          <div class="row form-group">
            <div class="col-sm-2">
              <label class="form-control border border-0 text-dark"> Điền post ID: </label>
            </div>
            <div class="col-sm-6">
              <input type="text" class="form-control" id="inp-post-id" placeholder="...Điền post id, ví dụ 2, 3...">
            </div>
            <div class="col-sm-4">
              <button class="btn btn-info form-control" id="btn-get-comment-list">Lấy danh sách bình luận của bài viết</button>
            </div>
          </div>
          <table class="table table-bordered table-striped table-hover text-center" id="tbl-post-id">
            <thead>
              <tr>
                <th>Id</th>
                <th>Post Id</th>
                <th>Email</th>
                <th>Name (nhan đề)</th>
                <th>Body (nội dung)</th>
                <th>Action</th>
              </tr>
            </thead>
            <tbody></tbody>
          </table>
        </div>
</body>
<script>
     "use strict";

     /*** REGION 1 - Global variables - Vùng khai báo hằng số, tham số TOÀN CỤC */
     const gCOL_ID = 0;
     const gCOL_POST_ID = 1;
     const gCOL_EMAIL = 2;
     const gCOL_NAME = 3
     const gCOL_BODY = 4
     const gCOL_ACTION = 5

     const gBASE_URL = "https://jsonplaceholder.typicode.com";
     /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
     $(document).ready(function(){
          //gán event handler cho nút lấy danh sách bình luận 
          $("#btn-get-comment-list").click(onBtnGetCommentListClick);
     });
     /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */

     //hàm xử lý việc nút lấy comment được click
     function onBtnGetCommentListClick(){
          //B1: Đọc dữ liệu 
          var vPostIdObj = {postId: 0};
          docDuLieu(vPostIdObj);
          //B2: Kiểm tra dữ liệu 
          var vKiemTra = kiemTraDuLieu(vPostIdObj);
          if(vKiemTra){
                //B3: gọi API
               $.ajax({
                    url: gBASE_URL + "/posts/" + vPostIdObj.postId + "/comments/",
                    type: "GET",   
                    dataType: "json", 
                    success: function(responseObject){
                         console.log((responseObject));
                         //4 xử lý hiện thị
                        loadTablePostId(responseObject);
                    },
                    error: function(ajaxContext){
                         alert(ajaxContext.responseText);
                    } 
               });
          }
     }
     /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/

     //hàm đọc dữ liệu 
     function docDuLieu(paramPostIdObj){
          paramPostIdObj.postId = parseInt($("#inp-post-id").val().trim());
     }

     //hàm kiểm tra dữ liệu 
     function kiemTraDuLieu(paramPostIdObj){
          if(isNaN(paramPostIdObj.postId) || paramPostIdObj.postId == ""){
               alert("Post ID phải nhập là số và không được bỏ trống!!!!");
               return false;
          }
          return true;
     }

     //hàm xử lý việc xóa dữ liệu của bảng 
     function resetTableData(){
          $("#tbl-post-id tbody").html("");  //truy câp bảng, rồi truy cập tbody, và xóa hết
     }
     //hàm load dữ liệu lên bảng 
     function  loadTablePostId(paramPost){
          //xóa dữ liệu của bản 
          resetTableData();

          //load dữ liệu lên bảng
          for(var bI = 0; bI < paramPost.length; bI++){
               //tạo row
               var bNewRow = $("<tr>").appendTo($("#tbl-post-id tbody"));
               
               //tạo cell
               $("<td>").html(paramPost[bI].postId).appendTo(bNewRow);
               $("<td>").html(paramPost[bI].id).appendTo(bNewRow);
               $("<td>").html(paramPost[bI].name).appendTo(bNewRow);
               $("<td>").html(paramPost[bI].email).appendTo(bNewRow);
               $("<td>").html(paramPost[bI].body).appendTo(bNewRow);

               //xử lý cột action có nút 
               var bColAction = $("<td>").addClass("btn-group").appendTo(bNewRow);//cột action
               //nút chi tiết

               var bDetailAction = $("<button>", {html: "Chi tiết"})
                    .addClass("btn btn-info")
                    .data("id", paramPost[bI].id)
                    .appendTo(bColAction);
               //thêm sự kiện cho nút 
               bDetailAction.click(onDetailButtonClick);
               
          }
     }

     //hàm xử lý sự kiện click button detail
    function onDetailButtonClick(paramSuKienClick) {
      console.log("%cDetail button click. Sự kiện Click là: ....", "color:orange");
      var vButtonBiAn = paramSuKienClick.currentTarget;
      const vFORM_TO_OPEN = "commentDetail.html"  //đây là form sẽ mở
      var vUrlToOpenPage = vFORM_TO_OPEN + "?"
        + "id=" + $(vButtonBiAn).data("id");
      window.location.href = vUrlToOpenPage;
    }
</script>
</html>